package com.zipcodewilmington;


import java.lang.reflect.Array;
import java.util.Arrays;

/**
 * Created by leon on 1/29/18.
 */
public class StringArrayUtils {
    /**
     * @param array array of String objects
     * @return first element of specified array
     */ // TODO
    public static String getFirstElement(String[] array) {

        return array[0];
    }

    /**
     * @param array array of String objects
     * @return second element in specified array
     */
    public static String getSecondElement(String[] array) {

        return array[1];
    }

    /**
     * @param array array of String objects
     * @return last element in specified array
     */ // TODO
    public static String getLastElement(String[] array) {

        return array[array.length - 1];
    }

    /**
     * @param array array of String objects
     * @return second to last element in specified array
     */ // TODO
    public static String getSecondToLastElement(String[] array) {

        return array[array.length - 2];
    }

    /**
     * @param array array of String objects
     * @param value value to check array for
     * @return true if the array contains the specified `value`
     */ // TODO
    public static boolean contains(String[] array, String value) {
        for (String counter : array) {
            if (counter.equals(value)) {
                return true;
            }
        }

        return false;
    }

    /**
     * @param array of String objects
     * @return an array with identical contents in reverse order
     */ // TODO
    public static String[] reverse(String[] array) {
        String[] reverseArray = new String[array.length];
        int b = 1;
        for (int j = 0; j < reverseArray.length; j++) {
            reverseArray[j] = array[array.length - b];
            b++;
        }


        return reverseArray;
    }

    /**
     * @param array array of String objects
     * @return true if the order of the array is the same backwards and forwards
     */ // TODO
    public static boolean isPalindromic(String[] array) {
        String[] testArray = reverse(Arrays.copyOf(array, array.length));

        return Arrays.equals(array, testArray);
    }

    /**
     * @param array array of String objects
     * @return true if each letter in the alphabet has been used in the array
     */ // TODO
    public static boolean isPangramic(String[] array) {
        String alphaString = Arrays.toString(array).toLowerCase();
        for (char l = 'a'; l <= 'z'; l++) {
            if (!alphaString.contains(String.valueOf(l))) {
                return false;
            }
        }
        return true;
    }

    /**
     * @param array array of String objects
     * @param value value to check array for
     * @return number of occurrences the specified `value` has occurred
     */ // TODO
    public static int getNumberOfOccurrences(String[] array, String value) {
        int counter = 0;
        for (String looper : array) {
            if (looper.equals(value)) {
                counter++;
            }
        }
        return counter;
    }

    /**
     * @param array         array of String objects
     * @param valueToRemove value to remove from array
     * @return array with identical contents excluding values of `value`
     */ // TODO
    public static String[] removeValue(String[] array, String valueToRemove) {
        String[] tempArray = new String[array.length];
        int newIdx = 0;
        for (int i = 0; i < array.length; i++) {
            if (array[i] != valueToRemove) {
                tempArray[newIdx] = array[i];
                newIdx++;
            }

        }
        return Arrays.copyOf(tempArray, newIdx);

    }

    /**
     * @param array array of chars
     * @return array of Strings with consecutive duplicates removes
     */ // TODO
    public static String[] removeConsecutiveDuplicates(String[] array) {
        String[] tempArray = new String[array.length];
        int newIdx = 0;

        for (int i = 1; i < array.length; i++) {
            String current = array[i - 1];
            if (!current.equals(array[i])) {
                tempArray[newIdx] = array[i - 1];
                newIdx++;
            }
        }
        tempArray[newIdx] = array[array.length - 1];
        return Arrays.copyOf(tempArray, newIdx + 1);

    }


    /**
     * @param array array of chars
     * @return array of Strings with each consecutive duplicate occurrence concatenated as a single string in an array of Strings
     */ // TODO
    public static String[] packConsecutiveDuplicates(String[] array) {
        String[] tempArray = new String[array.length];
        int newIdx = 0;
        String last = array[0];
        String combiner = array[0];

        for (int i = 1; i < array.length; i++) {
            if (!last.equals(array[i])) {
                last = array[i];
                tempArray[newIdx] = combiner;
                combiner = array[i];
                newIdx++;
            } else {
                combiner += array[i];

            }

        }
        tempArray[newIdx] = combiner;
        //tempArray[newIdx] = array[array.length - 1];
        return Arrays.copyOf(tempArray, newIdx + 1);

    }


}




